from asdl import const  # For const.NO_INTEGER
from asdl import py_meta
from core.runtime import TYPE_LOOKUP

class part_value_e(object):
  StringPartValue = 1
  ArrayPartValue = 2

class part_value(py_meta.CompoundObj):
  ASDL_TYPE = TYPE_LOOKUP.ByTypeName('part_value')

class StringPartValue(part_value):
  tag = 1
  ASDL_TYPE = TYPE_LOOKUP.ByTypeName('StringPartValue')
  __slots__ = ('s', 'do_split_glob', 'spids')

  def __init__(self, s=None, do_split_glob=None, spids=None):
    self.s = s
    self.do_split_glob = do_split_glob
    self.spids = spids or []

class ArrayPartValue(part_value):
  tag = 2
  ASDL_TYPE = TYPE_LOOKUP.ByTypeName('ArrayPartValue')
  __slots__ = ('strs', 'spids')

  def __init__(self, strs=None, spids=None):
    self.strs = strs or []
    self.spids = spids or []

class value_e(object):
  Undef = 1
  Str = 2
  StrArray = 3

class value(py_meta.CompoundObj):
  ASDL_TYPE = TYPE_LOOKUP.ByTypeName('value')

class Undef(value):
  ASDL_TYPE = TYPE_LOOKUP.ByTypeName('Undef')
  tag = 1

class Str(value):
  tag = 2
  ASDL_TYPE = TYPE_LOOKUP.ByTypeName('Str')
  __slots__ = ('s', 'spids')

  def __init__(self, s=None, spids=None):
    self.s = s
    self.spids = spids or []

class StrArray(value):
  tag = 3
  ASDL_TYPE = TYPE_LOOKUP.ByTypeName('StrArray')
  __slots__ = ('strs', 'spids')

  def __init__(self, strs=None, spids=None):
    self.strs = strs or []
    self.spids = spids or []

class cell(py_meta.CompoundObj):
  ASDL_TYPE = TYPE_LOOKUP.ByTypeName('cell')
  __slots__ = ('val', 'exported', 'readonly', 'spids')

  def __init__(self, val=None, exported=None, readonly=None, spids=None):
    self.val = val
    self.exported = exported
    self.readonly = readonly
    self.spids = spids or []

class var_flags_e(py_meta.SimpleObj):
  ASDL_TYPE = TYPE_LOOKUP.ByTypeName('var_flags')

var_flags_e.Exported = var_flags_e(1, 'Exported')
var_flags_e.ReadOnly = var_flags_e(2, 'ReadOnly')

class scope_e(py_meta.SimpleObj):
  ASDL_TYPE = TYPE_LOOKUP.ByTypeName('scope')

scope_e.TempEnv = scope_e(1, 'TempEnv')
scope_e.LocalOnly = scope_e(2, 'LocalOnly')
scope_e.GlobalOnly = scope_e(3, 'GlobalOnly')
scope_e.Dynamic = scope_e(4, 'Dynamic')

class lvalue_e(object):
  LhsName = 1
  LhsIndexedName = 2

class lvalue(py_meta.CompoundObj):
  ASDL_TYPE = TYPE_LOOKUP.ByTypeName('lvalue')

class LhsName(lvalue):
  tag = 1
  ASDL_TYPE = TYPE_LOOKUP.ByTypeName('LhsName')
  __slots__ = ('name', 'spids')

  def __init__(self, name=None, spids=None):
    self.name = name
    self.spids = spids or []

class LhsIndexedName(lvalue):
  tag = 2
  ASDL_TYPE = TYPE_LOOKUP.ByTypeName('LhsIndexedName')
  __slots__ = ('name', 'index', 'spids')

  def __init__(self, name=None, index=None, spids=None):
    self.name = name
    self.index = index
    self.spids = spids or []

class redirect_e(object):
  PathRedirect = 1
  DescRedirect = 2
  HereRedirect = 3

class redirect(py_meta.CompoundObj):
  ASDL_TYPE = TYPE_LOOKUP.ByTypeName('redirect')

class PathRedirect(redirect):
  tag = 1
  ASDL_TYPE = TYPE_LOOKUP.ByTypeName('PathRedirect')
  __slots__ = ('op_id', 'fd', 'filename', 'spids')

  def __init__(self, op_id=None, fd=None, filename=None, spids=None):
    self.op_id = op_id
    self.fd = fd
    self.filename = filename
    self.spids = spids or []

class DescRedirect(redirect):
  tag = 2
  ASDL_TYPE = TYPE_LOOKUP.ByTypeName('DescRedirect')
  __slots__ = ('op_id', 'fd', 'target_fd', 'spids')

  def __init__(self, op_id=None, fd=None, target_fd=None, spids=None):
    self.op_id = op_id
    self.fd = fd
    self.target_fd = target_fd
    self.spids = spids or []

class HereRedirect(redirect):
  tag = 3
  ASDL_TYPE = TYPE_LOOKUP.ByTypeName('HereRedirect')
  __slots__ = ('fd', 'body', 'spids')

  def __init__(self, fd=None, body=None, spids=None):
    self.fd = fd
    self.body = body
    self.spids = spids or []

class job_status_e(object):
  ProcessStatus = 1
  PipelineStatus = 2

class job_status(py_meta.CompoundObj):
  ASDL_TYPE = TYPE_LOOKUP.ByTypeName('job_status')

class ProcessStatus(job_status):
  tag = 1
  ASDL_TYPE = TYPE_LOOKUP.ByTypeName('ProcessStatus')
  __slots__ = ('status', 'spids')

  def __init__(self, status=None, spids=None):
    self.status = status
    self.spids = spids or []

class PipelineStatus(job_status):
  tag = 2
  ASDL_TYPE = TYPE_LOOKUP.ByTypeName('PipelineStatus')
  __slots__ = ('statuses', 'spids')

  def __init__(self, statuses=None, spids=None):
    self.statuses = statuses or []
    self.spids = spids or []

class span_e(py_meta.SimpleObj):
  ASDL_TYPE = TYPE_LOOKUP.ByTypeName('span')

span_e.Black = span_e(1, 'Black')
span_e.Delim = span_e(2, 'Delim')
span_e.Backslash = span_e(3, 'Backslash')

